diff -cr duel/duelgdb.c g:duel/duelgdb.c
*** duel/duelgdb.c	Sat Mar 20 16:35:48 1993
--- g:duel/duelgdb.c	Thu Oct 06 22:15:14 1994
***************
*** 95,102 ****
  #include "gdbcmd.h"
  #include "call-cmds.h"
  
! #include "duel/src/global.h"
! #include "duel/src/proto.h"
  
  /* all duel memory allocation go thru here */
  
--- 95,102 ----
  #include "gdbcmd.h"
  #include "call-cmds.h"
  
! #include "global.h"
! #include "proto.h"
  
  /* all duel memory allocation go thru here */
  
***************
*** 184,190 ****
   * otherwise, duel access target's memory directly.
   */
  
! LPROC duel_convert_value_from_gdb(value gv, tvalue *dv)
  {
    dv->ctype=duel_convert_type_from_gdb(VALUE_TYPE(gv));
    if(VALUE_LVAL(gv) == lval_memory) {
--- 184,190 ----
   * otherwise, duel access target's memory directly.
   */
  
! LPROC duel_convert_value_from_gdb(value_ptr gv, tvalue *dv)
  {
    dv->ctype=duel_convert_type_from_gdb(VALUE_TYPE(gv));
    if(VALUE_LVAL(gv) == lval_memory) {
***************
*** 210,218 ****
   * by making a gdb lvalue. but i am not sure how/what
   */
  
! LFUNC value convert_duel_val_to_gdb_val(tvalue *v)
  {
!    value gv ; 
     if(v->val_kind!=VK_RVALUE) return 0 ; /* cant handle lvals */
     switch(v->ctype->type_kind) {
  /* duel standardize func parms, so this code is not required. if this
--- 210,218 ----
   * by making a gdb lvalue. but i am not sure how/what
   */
  
! LFUNC value_ptr convert_duel_val_to_gdb_val(tvalue *v)
  {
!    value_ptr gv ; 
     if(v->val_kind!=VK_RVALUE) return 0 ; /* cant handle lvals */
     switch(v->ctype->type_kind) {
  /* duel standardize func parms, so this code is not required. if this
***************
*** 258,264 ****
  PROC duel_target_func_call(tvalue *func, tvalue *parms[],
                              int parms_no,tvalue *rval)
  {
!     value gfunc, grval, gparms[20] ;
      int i ;
      struct type *gftype ;
  
--- 258,264 ----
  PROC duel_target_func_call(tvalue *func, tvalue *parms[],
                              int parms_no,tvalue *rval)
  {
!     value_ptr gfunc, grval, gparms[20] ;
      int i ;
      struct type *gftype ;
  
***************
*** 369,374 ****
--- 369,381 ----
  	   if((char) -1 != -1) ct=ctype_char ;
  	   else ct=ctype_uchar ;
        }
+ #if 1
+       /* New type names used by GCC 2.5 (Eberhard Mattes, 23-Jun-1994) */
+       else if(strcmp(TYPE_NAME(t),"long int")==0)  ct=ctype_long ;
+       else if(strcmp(TYPE_NAME(t),"long unsigned int")==0)  ct=ctype_ulong ;
+       else if(strcmp(TYPE_NAME(t),"short int")==0) ct=ctype_short ;
+       else if(strcmp(TYPE_NAME(t),"short unsigned int")==0) ct=ctype_ushort ;
+ #endif
        break;
     case TYPE_CODE_FLT:
        if(strcmp(TYPE_NAME(t),"float")==0)  ct=ctype_float ;
***************
*** 492,498 ****
    FRAME frame ;
    struct block *blk ;
    int len ;
!   value gv ;                    /* gdb value */
  
    if(frame_no== -1) {           /* use the user selected frame and block */
        frame = selected_frame ;  
--- 499,505 ----
    FRAME frame ;
    struct block *blk ;
    int len ;
!   value_ptr gv ;                /* gdb value */
  
    if(frame_no== -1) {           /* use the user selected frame and block */
        frame = selected_frame ;  
***************
*** 551,557 ****
  {
     FRAME frame=duel_select_frame(frame_no);
     struct symbol *sym = get_frame_function(frame);
!    value val = read_var_value(sym,frame);
     duel_assert(val!=0 && VALUE_LVAL(val) == lval_memory);
  
     return (ttarget_ptr) VALUE_ADDRESS(val) ;
--- 558,564 ----
  {
     FRAME frame=duel_select_frame(frame_no);
     struct symbol *sym = get_frame_function(frame);
!    value_ptr val = read_var_value(sym,frame);
     duel_assert(val!=0 && VALUE_LVAL(val) == lval_memory);
  
     return (ttarget_ptr) VALUE_ADDRESS(val) ;
